diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/CMakeLists.txt ns-3.38/src/lr-wpan/examples/CMakeLists.txt
--- ns-3.37/src/lr-wpan/examples/CMakeLists.txt	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/lr-wpan/examples/CMakeLists.txt	2023-03-16 20:54:23.632868500 -0700
@@ -38,3 +38,10 @@
   LIBRARIES_TO_LINK ${liblr-wpan}
                     ${libnetanim}
 )
+
+build_lib_example(
+  NAME lr-wpan-per-plot
+  SOURCE_FILES lr-wpan-per-plot.cc
+  LIBRARIES_TO_LINK ${liblr-wpan}
+                    ${libstats}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/lr-wpan-active-scan.cc ns-3.38/src/lr-wpan/examples/lr-wpan-active-scan.cc
--- ns-3.37/src/lr-wpan/examples/lr-wpan-active-scan.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/lr-wpan/examples/lr-wpan-active-scan.cc	2023-03-16 20:54:23.632868500 -0700
@@ -60,7 +60,7 @@
     {
         std::cout << Simulator::Now().As(Time::S) << "| Active scan status SUCCESSFUL (Completed)"
                   << "\n";
-        if (params.m_panDescList.size() > 0)
+        if (!params.m_panDescList.empty())
         {
             std::cout << "Device [" << device->GetMac()->GetShortAddress()
                       << "] found the following PANs:\n";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.38/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.37/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2022-11-01 17:37:24.511395200 -0700
+++ ns-3.38/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2023-03-16 20:54:23.632868500 -0700
@@ -30,6 +30,9 @@
  * on the LQI results of the scan. A node may not find any beacons if the coordinator is outside its
  * communication range. An association request may not be send if LQI is too low for an association.
  *
+ * The coordinator in PAN 5 runs in extended addressing mode and do not assign short addresses.
+ * The coordinator in PAN 7 runs in short addressing mode and assign short addresses.
+ *
  * At the end of the simulation, an animation is generated (lrwpan-bootstrap.xml), showing the
  * results of the association with each coordinator. This simulation can take a few seconds to
  * complete.
@@ -90,7 +93,7 @@
         // Select the coordinator with the highest LQI from the PAN Descriptor List
         int maxLqi = 0;
         int panDescIndex = 0;
-        if (params.m_panDescList.size() > 0)
+        if (!params.m_panDescList.empty())
         {
             for (uint32_t i = 0; i < params.m_panDescList.size(); i++)
             {
@@ -104,11 +107,22 @@
             // Only request association if the coordinator is permitting association at this moment.
             if (params.m_panDescList[panDescIndex].m_superframeSpec.IsAssocPermit())
             {
+                std::string addressing;
+                if (params.m_panDescList[panDescIndex].m_coorAddrMode == SHORT_ADDR)
+                {
+                    addressing = "Short";
+                }
+                else if (params.m_panDescList[panDescIndex].m_coorAddrMode == EXT_ADDR)
+                {
+                    addressing = "Ext";
+                }
+
                 std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId()
                           << " [" << device->GetMac()->GetShortAddress() << " | "
                           << device->GetMac()->GetExtendedAddress() << "]"
                           << " MLME-scan.confirm:  Selected PAN ID "
-                          << params.m_panDescList[panDescIndex].m_coorPanId << " | LQI "
+                          << params.m_panDescList[panDescIndex].m_coorPanId
+                          << "| Coord addressing mode: " << addressing << " | LQI "
                           << static_cast<int>(params.m_panDescList[panDescIndex].m_linkQuality)
                           << "\n";
 
@@ -126,6 +140,7 @@
                         assocParams.m_coordAddrMode = LrWpanAddressMode::SHORT_ADDR;
                         assocParams.m_coordShortAddr =
                             params.m_panDescList[panDescIndex].m_coorShortAddr;
+                        assocParams.m_capabilityInfo.SetShortAddrAllocOn(true);
                     }
                     else if (assocParams.m_coordAddrMode == LrWpanAddressMode::EXT_ADDR)
                     {
@@ -133,6 +148,7 @@
                         assocParams.m_coordExtAddr =
                             params.m_panDescList[panDescIndex].m_coorExtAddr;
                         assocParams.m_coordShortAddr = Mac16Address("ff:fe");
+                        assocParams.m_capabilityInfo.SetShortAddrAllocOn(false);
                     }
 
                     Simulator::ScheduleNow(&LrWpanMac::MlmeAssociateRequest,
@@ -169,13 +185,14 @@
 static void
 AssociateIndication(Ptr<LrWpanNetDevice> device, MlmeAssociateIndicationParams params)
 {
-    // This is typically implemented by the  Coordinator next layer (3rd layer or higher).
+    // This is typically implemented by the coordinator next layer (3rd layer or higher).
     // The steps described below are out of the scope of the standard.
 
     // Here the 3rd layer should check:
-    //    a) Whether or not the device was previously associated with this PAN (the coordinator
-    //    keeps a list). b) The coordinator have sufficient resources available to allow the
-    //    association.
+    //    a) Whether or not the device was previously associated with this PAN
+    //       (the coordinator keeps a list).
+    //    b) The coordinator have sufficient resources available to allow the
+    //       association.
     // If the association fails, status = 1 or 2 and assocShortAddr = FFFF.
 
     // In this example, the coordinator accepts every association request and have no association
@@ -360,7 +377,8 @@
     NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
     lrwpanDevices.Add(lrWpanHelper.Install(coordinators));
 
-    lrWpanHelper.AssociateToPan(lrwpanDevices, 0xffff);
+    // Set the extended address to all devices (EUI-64)
+    lrWpanHelper.SetExtendedAddresses(lrwpanDevices);
 
     // Devices hooks & MAC MLME-scan primitive set
     for (NodeContainer::Iterator i = nodes.Begin(); i != nodes.End(); i++)
@@ -417,6 +435,16 @@
     Ptr<NetDevice> netDeviceCoor2 = coor2->GetDevice(0);
     Ptr<LrWpanNetDevice> coor2Device = DynamicCast<LrWpanNetDevice>(netDeviceCoor2);
 
+    // Coordinators require that their short address is explicitly set.
+    // Either FF:FE to indicate that only extended addresses will be used in the following
+    // data communications or any other value (except for FF:FF) to indicate that the coordinator
+    // will use the short address in these communications.
+    // The default short address for all devices is FF:FF (unassigned/no associated).
+
+    // coor1 (PAN 5) = extended addressing mode coor2 (PAN 7) = short addressing mode
+    coor1Device->GetMac()->SetShortAddress(Mac16Address("FF:FE"));
+    coor2Device->GetMac()->SetShortAddress(Mac16Address("CA:FE"));
+
     // PAN coordinator 1 (PAN 5) transmits beacons on channel 12
     MlmeStartRequestParams params;
     params.m_panCoor = true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.38/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.37/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2023-03-16 20:54:23.632868500 -0700
@@ -17,11 +17,25 @@
  * Author: Tom Henderson <thomas.r.henderson@boeing.com>
  */
 
-// This program produces a gnuplot file that plots the packet success rate
-// as a function of distance for the 802.15.4 models, assuming a default
-// LogDistance propagation loss model, the 2.4 GHz OQPSK error model, a
-// default transmit power of 0 dBm, and a default packet size of 20 bytes of
-// 802.15.4 payload.
+/*
+   This program produces a gnuplot file that plots the packet success rate
+   as a function of distance for the 802.15.4 models, assuming a default
+   LogDistance propagation loss model, the 2.4 GHz OQPSK error model, a
+   default transmit power of 0 dBm, and a default packet size of 20 bytes of
+   802.15.4 payload and a default rx sensitivity of -106.58 dBm.
+
+   Tx power of the transmitter node and the Rx sensitivity of the receiving node
+   as well as the transmitted packet size can be adjusted to obtain a different
+   distance plot.
+
+    Node1                       Node2
+   (dev0) --------------------->(dev1)
+
+   Usage:
+
+   ./ns3 run "lr-wpan-error-distance-plot --txPower= 0 --rxSensitivity=-92"
+
+*/
 #include <ns3/abort.h>
 #include <ns3/callback.h>
 #include <ns3/command-line.h>
@@ -52,7 +66,7 @@
 
 using namespace ns3;
 
-static uint32_t g_received = 0; //!< number of packets received
+uint32_t g_packetsReceived = 0; //!< number of packets received
 
 NS_LOG_COMPONENT_DEFINE("LrWpanErrorDistancePlot");
 
@@ -61,10 +75,10 @@
  * \param params MCPS data indication parameters
  * \param p packet
  */
-static void
+void
 LrWpanErrorDistanceCallback(McpsDataIndicationParams params, Ptr<Packet> p)
 {
-    g_received++;
+    g_packetsReceived++;
 }
 
 int
@@ -77,20 +91,22 @@
     int maxDistance = 200; // meters
     int increment = 1;
     int maxPackets = 1000;
-    int packetSize = 20;
+    int packetSize = 7; // PSDU = 20 bytes (11 bytes MAC header + 7 bytes MSDU )
     double txPower = 0;
     uint32_t channelNumber = 11;
+    double rxSensitivity = -106.58; // dBm
 
     CommandLine cmd(__FILE__);
 
     cmd.AddValue("txPower", "transmit power (dBm)", txPower);
     cmd.AddValue("packetSize", "packet (MSDU) size (bytes)", packetSize);
     cmd.AddValue("channelNumber", "channel number", channelNumber);
+    cmd.AddValue("rxSensitivity", "the rx sensitivity (dBm)", rxSensitivity);
 
     cmd.Parse(argc, argv);
 
     os << "Packet (MSDU) size = " << packetSize << " bytes; tx power = " << txPower
-       << " dBm; channel = " << channelNumber;
+       << " dBm; channel = " << channelNumber << "; Rx sensitivity = " << rxSensitivity << " dBm";
 
     Gnuplot psrplot = Gnuplot("802.15.4-psr-distance.eps");
     Gnuplot2dDataset psrdataset("802.15.4-psr-vs-distance");
@@ -117,6 +133,9 @@
     Ptr<SpectrumValue> psd = svh.CreateTxPowerSpectralDensity(txPower, channelNumber);
     dev0->GetPhy()->SetTxPowerSpectralDensity(psd);
 
+    // Set Rx sensitivity of the receiving device
+    dev1->GetPhy()->SetRxSensitivity(rxSensitivity);
+
     McpsDataIndicationCallback cb0;
     cb0 = MakeCallback(&LrWpanErrorDistanceCallback);
     dev1->GetMac()->SetMcpsDataIndicationCallback(cb0);
@@ -132,7 +151,7 @@
     Ptr<Packet> p;
     mob0->SetPosition(Vector(0, 0, 0));
     mob1->SetPosition(Vector(minDistance, 0, 0));
-    for (int j = minDistance; j < maxDistance;)
+    for (int j = minDistance; j < maxDistance; j += increment)
     {
         for (int i = 0; i < maxPackets; i++)
         {
@@ -140,10 +159,10 @@
             Simulator::Schedule(Seconds(i), &LrWpanMac::McpsDataRequest, dev0->GetMac(), params, p);
         }
         Simulator::Run();
-        NS_LOG_DEBUG("Received " << g_received << " packets for distance " << j);
-        psrdataset.Add(j, g_received / 1000.0);
-        g_received = 0;
-        j += increment;
+        NS_LOG_DEBUG("Received " << g_packetsReceived << " packets for distance " << j);
+        psrdataset.Add(j, g_packetsReceived / 1000.0);
+        g_packetsReceived = 0;
+
         mob1->SetPosition(Vector(j, 0, 0));
     }
 
@@ -153,10 +172,10 @@
     psrplot.SetTerminal("postscript eps color enh \"Times-BoldItalic\"");
     psrplot.SetLegend("distance (m)", "Packet Success Rate (PSR)");
     psrplot.SetExtra("set xrange [0:200]\n\
-set yrange [0:1]\n\
-set grid\n\
-set style line 1 linewidth 5\n\
-set style increment user");
+                      set yrange [0:1]\n\
+                      set grid\n\
+                      set style line 1 linewidth 5\n\
+                      set style increment user");
     psrplot.GenerateOutput(berfile);
     berfile.close();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/lr-wpan-mlme.cc ns-3.38/src/lr-wpan/examples/lr-wpan-mlme.cc
--- ns-3.37/src/lr-wpan/examples/lr-wpan-mlme.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/examples/lr-wpan-mlme.cc	2023-03-16 20:54:23.632868500 -0700
@@ -46,21 +46,20 @@
 
 using namespace ns3;
 
-static void
-BeaconIndication(MlmeBeaconNotifyIndicationParams params, Ptr<Packet> p)
+void
+BeaconIndication(MlmeBeaconNotifyIndicationParams params)
 {
-    NS_LOG_UNCOND(Simulator::Now().GetSeconds()
-                  << " secs | Received BEACON packet of size " << p->GetSize());
+    NS_LOG_UNCOND(Simulator::Now().GetSeconds() << " secs | Received BEACON packet of size ");
 }
 
-static void
+void
 DataIndication(McpsDataIndicationParams params, Ptr<Packet> p)
 {
     NS_LOG_UNCOND(Simulator::Now().GetSeconds()
                   << " secs | Received DATA packet of size " << p->GetSize());
 }
 
-static void
+void
 TransEndIndication(McpsDataConfirmParams params)
 {
     // In the case of transmissions with the Ack flag activated, the transaction is only
@@ -71,19 +70,19 @@
     }
 }
 
-static void
+void
 DataIndicationCoordinator(McpsDataIndicationParams params, Ptr<Packet> p)
 {
     NS_LOG_UNCOND(Simulator::Now().GetSeconds()
                   << "s Coordinator Received DATA packet (size " << p->GetSize() << " bytes)");
 }
 
-static void
+void
 StartConfirm(MlmeStartConfirmParams params)
 {
     if (params.m_status == MLMESTART_SUCCESS)
     {
-        NS_LOG_UNCOND(Simulator::Now().GetSeconds() << "Beacon status SUCESSFUL");
+        NS_LOG_UNCOND(Simulator::Now().GetSeconds() << "Beacon status SUCCESSFUL");
     }
 }
 
@@ -156,7 +155,7 @@
 
     //////////// Manual device association ////////////////////
     // Note: We manually associate the devices to a PAN coordinator
-    //       because currently there is no automatic association behavior (bootstrap);
+    //       (i.e. bootstrap is not used);
     //       The PAN COORDINATOR does not need to associate or set its
     //       PAN Id or its own coordinator id, these are set
     //       by the MLME-start.request primitive when used.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/examples/lr-wpan-per-plot.cc ns-3.38/src/lr-wpan/examples/lr-wpan-per-plot.cc
--- ns-3.37/src/lr-wpan/examples/lr-wpan-per-plot.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/lr-wpan/examples/lr-wpan-per-plot.cc	2023-03-16 20:54:23.632868500 -0700
@@ -0,0 +1,251 @@
+/*
+ * Copyright (c) 2022 Tokushima University, Japan
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ *          Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+/*
+   This program produces a gnuplot file that plots the theoretical and experimental packet error
+   rate (PER) as a function of receive signal for the 802.15.4 model. As described by the standard,
+   the PER is calculated with the transmission of frames with a PSDU of 20 bytes. This is equivalent
+   to an MPDU = MAC header (11 bytes) + FCS (2 bytes) +  payload (MSDU 7 bytes). In the experimental
+   test, 1000 frames are transmitted for each Rx signal ranging from -130 dBm to -100 dBm with
+   increments of 0.01 dBm. The point before PER is < 1 % is the device receive sensitivity.
+   Theoretical and experimental Rx sensitivity is printed at the end of the end and a plot is
+   generated.
+
+   Example usage:
+
+   ./ns3 run "lr-wpan-per-plot --rxSensitivity=-92"
+
+*/
+
+#include <ns3/core-module.h>
+#include <ns3/gnuplot.h>
+#include <ns3/lr-wpan-module.h>
+#include <ns3/mobility-module.h>
+#include <ns3/network-module.h>
+#include <ns3/propagation-module.h>
+#include <ns3/spectrum-module.h>
+
+using namespace ns3;
+
+uint32_t g_packetsReceived = 0; //!< number of packets received
+
+NS_LOG_COMPONENT_DEFINE("LrWpanErrorDistancePlot");
+
+/**
+ * Function called when a Data indication is invoked
+ * \param params MCPS data indication parameters
+ * \param p packet
+ */
+void
+PacketReceivedCallback(McpsDataIndicationParams params, Ptr<Packet> p)
+{
+    g_packetsReceived++;
+}
+
+int
+main(int argc, char* argv[])
+{
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_FUNC | LOG_PREFIX_NODE | LOG_PREFIX_TIME));
+
+    std::ostringstream os;
+    std::ofstream perfile("802.15.4-per-vs-rxSignal.plt");
+
+    double minRxSignal = -111; // dBm
+    double maxRxSignal = -82;  // dBm
+    double increment = 0.01;
+    int maxPackets = 1000;
+    int packetSize = 7; // bytes (MPDU payload)
+    double txPower = 0; // dBm
+    uint32_t channelNumber = 11;
+    double rxSensitivity = -106.58; // dBm
+
+    CommandLine cmd(__FILE__);
+
+    cmd.AddValue("txPower", "transmit power (dBm)", txPower);
+    cmd.AddValue("packetSize", "packet (MSDU) size (bytes)", packetSize);
+    cmd.AddValue("channelNumber", "channel number", channelNumber);
+    cmd.AddValue("rxSensitivity", "the rx sensitivity (dBm)", rxSensitivity);
+    cmd.Parse(argc, argv);
+
+    Gnuplot perplot = Gnuplot("802.15.4-per-vs-rxSignal.eps");
+    Gnuplot2dDataset perdatasetExperimental("Experimental");
+    Gnuplot2dDataset perdatasetTheorical("Theoretical");
+
+    Ptr<Node> n0 = CreateObject<Node>();
+    Ptr<Node> n1 = CreateObject<Node>();
+    Ptr<LrWpanNetDevice> dev0 = CreateObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> dev1 = CreateObject<LrWpanNetDevice>();
+
+    dev0->SetAddress(Mac16Address("00:01"));
+    dev1->SetAddress(Mac16Address("00:02"));
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    Ptr<FixedRssLossModel> propModel = CreateObject<FixedRssLossModel>();
+
+    channel->AddPropagationLossModel(propModel);
+    dev0->SetChannel(channel);
+    dev1->SetChannel(channel);
+    n0->AddDevice(dev0);
+    n1->AddDevice(dev1);
+    Ptr<ConstantPositionMobilityModel> mob0 = CreateObject<ConstantPositionMobilityModel>();
+    dev0->GetPhy()->SetMobility(mob0);
+    Ptr<ConstantPositionMobilityModel> mob1 = CreateObject<ConstantPositionMobilityModel>();
+    dev1->GetPhy()->SetMobility(mob1);
+    mob0->SetPosition(Vector(0, 0, 0));
+    mob1->SetPosition(Vector(0, 0, 0));
+
+    LrWpanSpectrumValueHelper svh;
+    Ptr<SpectrumValue> psd = svh.CreateTxPowerSpectralDensity(txPower, channelNumber);
+    dev0->GetPhy()->SetTxPowerSpectralDensity(psd);
+
+    // Set Rx sensitivity of the receiving device
+    dev1->GetPhy()->SetRxSensitivity(rxSensitivity);
+
+    McpsDataIndicationCallback cb0;
+    cb0 = MakeCallback(&PacketReceivedCallback);
+    dev1->GetMac()->SetMcpsDataIndicationCallback(cb0);
+
+    //////////////////////////////////
+    // Experimental  PER v.s Signal //
+    //////////////////////////////////
+
+    double per = 1;
+    double sensitivityExp = 0;
+    bool sensThreshold = true;
+
+    for (double j = minRxSignal; j < maxRxSignal; j += increment)
+    {
+        propModel->SetRss(j);
+        if (sensThreshold)
+        {
+            sensitivityExp = j;
+        }
+
+        for (int i = 0; i < maxPackets; i++)
+        {
+            McpsDataRequestParams params;
+            params.m_srcAddrMode = SHORT_ADDR;
+            params.m_dstAddrMode = SHORT_ADDR;
+            params.m_dstPanId = 0;
+            params.m_dstAddr = Mac16Address("00:02");
+            params.m_msduHandle = 0;
+            params.m_txOptions = 0;
+            Ptr<Packet> p;
+            p = Create<Packet>(packetSize);
+            Simulator::Schedule(Seconds(i), &LrWpanMac::McpsDataRequest, dev0->GetMac(), params, p);
+        }
+
+        Simulator::Run();
+
+        per = (static_cast<double>(maxPackets - g_packetsReceived) / maxPackets) * 100;
+
+        std::cout << "Experimental Test || Signal: " << j << " dBm | Received " << g_packetsReceived
+                  << " pkts"
+                  << "/" << maxPackets << " | PER " << per << " %\n";
+
+        if (per <= 1 && sensThreshold)
+        {
+            sensThreshold = false;
+        }
+
+        perdatasetExperimental.Add(j, per);
+        g_packetsReceived = 0;
+    }
+
+    /////////////////////////////////
+    // Theoretical PER v.s. Signal //
+    /////////////////////////////////
+
+    Ptr<LrWpanErrorModel> lrWpanError = CreateObject<LrWpanErrorModel>();
+    LrWpanSpectrumValueHelper psdHelper;
+
+    // Calculate the noise that accounts for both thermal noise (floor noise) and
+    // imperfections on the chip or lost before reaching the demodulator.
+    // In O-QPSK 250kbps, the point where PER is <= 1% without
+    // additional noise is -106.58 dBm (Noise Factor = 1)
+    double maxRxSensitivityW = (pow(10.0, -106.58 / 10.0) / 1000.0);
+    long double noiseFactor = (pow(10.0, rxSensitivity / 10.0) / 1000.0) / maxRxSensitivityW;
+
+    psdHelper.SetNoiseFactor(noiseFactor);
+    Ptr<const SpectrumValue> noisePsd = psdHelper.CreateNoisePowerSpectralDensity(11);
+    double noise = LrWpanSpectrumValueHelper::TotalAvgPower(noisePsd, 11);
+
+    double signal = 0;
+    double sensitivityTheo = 0;
+    double perTheoretical = 0;
+    double snr = 0;
+    sensThreshold = true;
+
+    for (double j = minRxSignal; j < maxRxSignal; j += increment)
+    {
+        if (sensThreshold)
+        {
+            sensitivityTheo = j;
+        }
+
+        signal = pow(10.0, j / 10.0) / 1000.0; // signal in Watts
+        snr = signal / noise;
+
+        // According to the standard, Packet error rate should be obtained
+        // using a PSDU of 20 bytes using
+        // the equation PER = 1 - (1 - BER)^nbits
+        perTheoretical = (1.0 - lrWpanError->GetChunkSuccessRate(snr, (packetSize + 13) * 8)) * 100;
+        std::cout << "Theoretical Test || Signal: " << j << " dBm | SNR: " << snr << "| PER "
+                  << perTheoretical << " % \n";
+
+        if (perTheoretical <= 1 && sensThreshold)
+        {
+            sensThreshold = false;
+        }
+
+        perdatasetTheorical.Add(j, perTheoretical);
+    }
+
+    std::cout << "_____________________________________________________________________________\n";
+    std::cout << "Experimental Test || Receiving with a current sensitivity of " << sensitivityExp
+              << " dBm\n";
+    std::cout << "Theoretical Test  || Receiving with a current sensitivity of " << sensitivityTheo
+              << " dBm\n";
+    std::cout << "Gnu plot generated.";
+
+    os << "Pkt Payload (MSDU) size = " << packetSize << " bytes | "
+       << "Tx power = " << txPower << " dBm | "
+       << "Rx Sensitivity (Theo) = " << sensitivityTheo << " dBm";
+
+    perplot.AddDataset(perdatasetExperimental);
+    perplot.AddDataset(perdatasetTheorical);
+
+    perplot.SetTitle(os.str());
+    perplot.SetTerminal("postscript eps color enh \"Times-BoldItalic\"");
+    perplot.SetLegend("Rx signal (dBm)", "Packet Error Rate (%)");
+    perplot.SetExtra("set xrange [-110:-82]\n\
+                      set logscale y\n\
+                      set yrange [0.000000000001:120]\n\
+                      set xtics 2\n\
+                      set grid\n\
+                      set style line 1 linewidth 5\n\
+                      set style line 2 linewidth 3\n\
+                      set style increment user\n\
+                      set arrow from -110,1 to -82,1 nohead lc 'web-blue' front");
+    perplot.GenerateOutput(perfile);
+    perfile.close();
+
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/helper/lr-wpan-helper.cc ns-3.38/src/lr-wpan/helper/lr-wpan-helper.cc
--- ns-3.37/src/lr-wpan/helper/lr-wpan-helper.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/helper/lr-wpan-helper.cc	2023-03-16 20:54:23.632868500 -0700
@@ -231,85 +231,80 @@
 }
 
 void
-LrWpanHelper::AssociateToPan(NetDeviceContainer c, uint16_t panId)
+LrWpanHelper::CreateAssociatedPan(NetDeviceContainer c, uint16_t panId)
 {
     NetDeviceContainer devices;
     uint16_t id = 1;
-    uint8_t idBuf[2];
+    uint8_t idBuf[2] = {0, 0};
+    uint8_t idBuf2[8] = {0, 0, 0, 0, 0, 0, 0, 0};
+    Mac16Address address16;
+    Mac64Address address64;
+    Mac16Address coordShortAddr;
+    Mac64Address coordExtAddr;
 
     for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); i++)
     {
+        if (id < 0x0001 || id > 0xFFFD)
+        {
+            NS_ABORT_MSG("Only 65533 addresses supported. Range [00:01]-[FF:FD]");
+        }
+
         Ptr<LrWpanNetDevice> device = DynamicCast<LrWpanNetDevice>(*i);
         if (device)
         {
             idBuf[0] = (id >> 8) & 0xff;
             idBuf[1] = (id >> 0) & 0xff;
-            Mac16Address address;
-            address.CopyFrom(idBuf);
+            address16.CopyFrom(idBuf);
+
+            idBuf2[6] = (id >> 8) & 0xff;
+            idBuf2[7] = (id >> 0) & 0xff;
+            address64.CopyFrom(idBuf2);
+
+            if (address64 == Mac64Address("00:00:00:00:00:00:00:01"))
+            {
+                // We use the first device in the container as coordinator
+                coordShortAddr = address16;
+                coordExtAddr = address64;
+            }
+
+            // TODO: Change this to device->GetAddress() if GetAddress can guarantee a
+            //  an extended address (currently only gives 48 address or 16 bits addresses)
+            device->GetMac()->SetExtendedAddress(address64);
+            device->SetPanAssociation(panId, coordExtAddr, coordShortAddr, address16);
 
-            device->GetMac()->SetPanId(panId);
-            device->GetMac()->SetShortAddress(address);
             id++;
         }
     }
 }
 
 void
-LrWpanHelper::AssociateToBeaconPan(NetDeviceContainer c,
-                                   uint16_t panId,
-                                   Mac16Address coor,
-                                   uint8_t bcnOrd,
-                                   uint8_t sfrmOrd)
+LrWpanHelper::SetExtendedAddresses(NetDeviceContainer c)
 {
     NetDeviceContainer devices;
-    uint16_t id = 1;
-    uint8_t idBuf[2];
-    Mac16Address address;
-
-    if (bcnOrd > 14)
-    {
-        NS_LOG_DEBUG("The Beacon Order must be an int between 0 and 14");
-        return;
-    }
-
-    if ((sfrmOrd > 14) || (sfrmOrd > bcnOrd))
-    {
-        NS_LOG_DEBUG("The Superframe Order must be an int between 0 and 14, and less or equal to "
-                     "Beacon Order");
-        return;
-    }
+    uint64_t id = 1;
+    uint8_t idBuf[8] = {0, 0, 0, 0, 0, 0, 0, 0};
+    Mac64Address address64;
 
     for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); i++)
     {
         Ptr<LrWpanNetDevice> device = DynamicCast<LrWpanNetDevice>(*i);
         if (device)
         {
-            idBuf[0] = (id >> 8) & 0xff;
-            idBuf[1] = (id >> 0) & 0xff;
-            address.CopyFrom(idBuf);
-
-            device->GetMac()->SetShortAddress(address);
+            idBuf[0] = (id >> 56) & 0xff;
+            idBuf[1] = (id >> 48) & 0xff;
+            idBuf[2] = (id >> 40) & 0xff;
+            idBuf[3] = (id >> 32) & 0xff;
+            idBuf[4] = (id >> 24) & 0xff;
+            idBuf[5] = (id >> 16) & 0xff;
+            idBuf[6] = (id >> 8) & 0xff;
+            idBuf[7] = (id >> 0) & 0xff;
+
+            address64.CopyFrom(idBuf);
+
+            // TODO: Change this to device->SetAddress() if GetAddress can guarantee
+            //  to set only extended addresses
+            device->GetMac()->SetExtendedAddress(address64);
 
-            if (address == coor)
-            {
-                MlmeStartRequestParams params;
-                params.m_panCoor = true;
-                params.m_PanId = panId;
-                params.m_bcnOrd = bcnOrd;
-                params.m_sfrmOrd = sfrmOrd;
-
-                Ptr<UniformRandomVariable> uniformRandomVariable =
-                    CreateObject<UniformRandomVariable>();
-                ;
-                Time jitter = Time(MilliSeconds(uniformRandomVariable->GetInteger(0, 10)));
-
-                Simulator::Schedule(jitter, &LrWpanMac::MlmeStartRequest, device->GetMac(), params);
-            }
-            else
-            {
-                device->GetMac()->SetPanId(panId);
-                device->GetMac()->SetAssociatedCoor(coor);
-            }
             id++;
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/helper/lr-wpan-helper.h ns-3.38/src/lr-wpan/helper/lr-wpan-helper.h
--- ns-3.37/src/lr-wpan/helper/lr-wpan-helper.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/helper/lr-wpan-helper.h	2023-03-16 20:54:23.632868500 -0700
@@ -109,29 +109,23 @@
     NetDeviceContainer Install(NodeContainer c);
 
     /**
-     * \brief Associate the nodes to the same PAN
+     * \brief Creates an PAN with associated nodes and assigned addresses(16 and 64)
+     *        from the nodes in the node container.
+     *        The first node in the container becomes the PAN coordinator.
      *
-     * \param c a set of nodes
-     * \param panId the PAN Id
+     * \param c a The node container with the nodes that will form the PAN.
+     * \param panId The PAN identifier.
      */
-    void AssociateToPan(NetDeviceContainer c, uint16_t panId);
+    void CreateAssociatedPan(NetDeviceContainer c, uint16_t panId);
 
     /**
-     * \brief Associate the nodes to the same PAN and initiate beacon enabled mode.
+     * \brief Set the extended 64 bit addresses (EUI-64) for a group of
+     *        LrWpanNetDevices
+     *
+     * \param c The NetDevice container.
      *
-     * \param c a set of nodes
-     * \param panId the PAN id
-     * \param coor the address of the PAN coordinator
-     * \param bcnOrd indicates the interval between beacons.
-     *               The value must be an int between 0 and 14.
-     * \param sfrmOrd indicates the length of the superframe.
-     *                The value must be an int between 0 and 14 and less or equal to the bcnOrd
      */
-    void AssociateToBeaconPan(NetDeviceContainer c,
-                              uint16_t panId,
-                              Mac16Address coor,
-                              uint8_t bcnOrd,
-                              uint8_t sfrmOrd);
+    void SetExtendedAddresses(NetDeviceContainer c);
 
     /**
      * Helper to enable all LrWpan log components with one statement
